#include <libxml/parser.h>
#include <libxml/tree.h>
#include "eggtrayicon.h"
#include <time.h>

int  get_all_due_dates();
xmlNodePtr  get_id_node(gchar *category, gint id);
extern GtkWidget *window;
extern GtkListStore *list;

#ifdef ENABLE_NLS
#include <libintl.h>
#include <locale.h>
#define _(String) gettext (String)
#  ifdef gettext_noop
#    define N_(String) gettext_noop (String)
#  else
#    define N_(String) (String)
#  endif
#else 
#define _(String) String
#endif


extern xmlNodePtr  root;
extern xmlDocPtr   my_xml_tree;
void save_xml();
enum
{
    ID,
    PRIORITY,
    PRIOSTR,
    DONE,
    SUMMARY,
    COMMENT,
    END_DATE,
    EDITABLE,
    COLOR,
    CATEGORY,
    F_DATE, /* a formated date string */
    START_DATE,
    COMPLETED_DATE,
    DUE,
    N_COL
};

typedef struct{
    GtkWidget *item;
    gchar *date;
} catitems;

typedef struct{
    GtkWidget *window;
    GtkWidget *vbox;
    GtkWidget *hbox;
    GtkWidget *treeview;
    GtkWidget *statusbar;
    GtkWidget *toolbar;
    GtkListStore *list;
    GtkWidget *tbdelbut, *tbaddbut, *tbeditbut;
    GtkWidget *option, *menu;
    catitems **mitems;
    GtkAccelGroup *accel_group;
    GtkItemFactory *item_factory;

    } mwindow;

typedef struct
	{
	gboolean do_tray;
	gint lastid;
	gboolean size, place;
	gboolean ask_delete_category;
	gboolean show_date_column;
	gboolean list_tooltip;
	gboolean auto_purge;
	gint purge_days;
	}sets;
	
extern sets settings;
void quit_program();

/*interface.c*/
extern mwindow mw;
void gui_create_main_window();
void gui_add_todo_item(GtkWidget *useless, gpointer data);
/* callback.c*/
void remove_todo_item(GtkWidget *fake, gboolean internall);
int tray_clicked(GtkWidget *image, GdkEventButton *event);
void read_categorys();
void load_category();
void save_category();
void category_changed();
extern int categorys;
void save_categorys();
void change_category();
void delete_category();
extern gulong shand;
void add_category();
extern GtkTooltips *tray_icon_tooltip;
extern EggTrayIcon *tray_icon;
int tree_clicked(GtkWidget *tree, GdkEventButton *event);
void list_toggled_done(GtkCellRendererToggle *cell, gchar *path_str);
extern int hidden;
void tray_destroyed(GtkObject *object, gpointer data);
void gui_preferences();
void purge_category();
int message_box(gchar *text,gchar *buttext, GtkMessageType type);
void category_manager();
extern gboolean tray;
gboolean mw_motion_cb (GtkWidget *tv, GdkEventMotion *event, gpointer null);
void mw_leave_cb (GtkWidget *w, GdkEventCrossing *e, gpointer n);
int  get_all_past_purge();
